/*	------------------------------------------------------------------------------------------
	Author: Benedikt Rey
	Date: 04.05.2012
	Version: v1.1
*/	------------------------------------------------------------------------------------------

zzTk = "BipedPrepareMoCap.mcr"
UserMacrosDir = ((getdir #usermacros) + "\\" + "ReferenceBox.png")
UserMacrosScriptFile = ((getdir #usermacros) + "\\" + zzTk)
CurrentScriptDir = getThisScriptFilename()
MainMenuBar = menuMan.findMenu "Main Menu Bar"
if (menuMan.findMenu "BR Tools") == undefined then BRTOOLMENU = menuMan.createMenu "BR Tools" else BRTOOLMENU = menuMan.findMenu "BR Tools"
testItem = menuMan.createActionItem "BipedPrepareMoCap" "BR Tools"
if (copyFile CurrentScriptDir UserMacrosScriptFile) == true do BRTOOLMENU.addItem testItem -1
menuMan.updateMenuBar()
if (copyFile CurrentScriptDir UserMacrosDir) == true then (copyFile CurrentScriptDir UserMacrosDir)
else (deleteFile UserMacrosDir) and (copyFile CurrentScriptDir UserMacrosDir)
HelpFile = ((trimright (getThisScriptFilename() as string) zzTk) + "Help.txt")
edit HelpFile

macroscript BipedPrepareMoCap
	category: "BR Tools"
	internalCategory: "BR Tools"
	buttonText: "Biped Prepare MoCap"
	icon: #("Systems",1)
	tooltip: "Prepares the MoCap of the Biped."
(
	fn ReduceTheKeys Bip =
	(
		NumArray = #(1,2,5,6,9,11,12,17)
		NodeArray = #()
		KeyNumStart = numKeys Bip.controller.horizontal.controller
		for op = 1 to NumArray.count do
		(
			NodeArray[op] = (biped.getNode Bip NumArray[op] link:1)
		)


		KeyNum = numKeys Bip.controller.horizontal.controller
		for t = 2 to KeyNum do
		(
			try (deleteKey Bip.controller.horizontal.controller t) catch()
			KeyNum = KeyNum as integer - 1
		)


		KeyNum = numKeys Bip.controller.vertical.controller
		for t = 2 to KeyNum do
		(
			try (deleteKey Bip.controller.vertical.controller t) catch()
			KeyNum = KeyNum as integer - 1
		)


		KeyNum = numKeys Bip.controller.turning.controller
		for t = 2 to KeyNum do
		(
			try (deleteKey Bip.controller.turning.controller t) catch()
			KeyNum = KeyNum as integer - 1
		)


		KeyNum = numKeys NodeArray[1].controller
		for i in NodeArray do
		(
			if i != undefined do
				(
					j = (execute("$'" + (i.name) + "'"))
					obj = j.controller
					
					
					for t = 2 to KeyNum do
					(
						try (deleteKey obj t) catch()
					)
					KeyNum = KeyNum as integer - 1
				)
		)

		global KeyNum = numKeys NodeArray[1].controller
		if KeyNumStart != 0 then messagebox ("Before: " + KeyNumStart as string + " Keys" + " - After: " + KeyNum as string + " Keys") else messagebox "Check, if you are on the right layer!\nBecause there are no Keys."
	)
	BipHipNode = $Bip001
	rollout PickBipRoot "Pick your Biped Root."
	(
		pickbutton pckBip "Pick Biped Root" tooltip:"Default is \"$Bip001\"" pos:[5,5]
		button btnReduceKeys "Reduce Keys" tooltip:"This will not allways be the best Solution!" pos:[5,30]
		checkbox chkfoot "Move Feet to z = 0" pos:[5,55]
		button btnstart "Start" pos:[5,80]
		button btnCancel "Cancel" pos:[65,80]
		on pckBip picked BipedNode do
		(
			BipHipNode = BipedNode
			pckBip.caption = BipedNode.name
		)
		on btnReduceKeys pressed do
		(
			rollout AreYouSure "Are You Sure?"
				(
					button btnYes "Yes"
					button btnCancel2 "Cancel"
					
					on btnYes pressed do
					(
						ReduceTheKeys BipHipNode
						try(destroydialog AreYouSure)catch()
					)
					on btnCancel2 pressed do
					(
						try(destroydialog AreYouSure)catch()
					)
				)
			createdialog AreYouSure
		)
		on btnCancel pressed do
		(
			try(destroydialog PickBipRoot)catch()
		)
		on btnstart pressed do
		(
			animationrange
			FrameRange = normTime 1
			CurrentSliderTime = sliderTime

			LToe = biped.getNode BipHipNode 7 link:1
			RToe = biped.getNode BipHipNode 8 link:1
			RToeRot = biped.getTransform RToe #rotation
			LToeRot = biped.getTransform LToe #rotation

			biped.createLayer BipHipNode.controller 1 "PelvisZero"
			if chkfoot.checked == true do biped.createLayer BipHipNode.controller 2 "ToeRotation"
			if chkfoot.checked == true do biped.createLayer BipHipNode.controller 3 "ToOver0"

			Percent = 25

			fn CreateThatPoint =
			(
				if $Check_L_Toe == undefined do
				(
					PointHelper = Point cross: true box: false size: 10 wirecolor: white
					PointHelper.transform = $'Bip001 L Toe0'.transform
					PointHelper.name = "Check_L_Toe"
					PointHelper.controller.position.controller = Position_Constraint ()
					PointHelper.controller.position.controller.appendTarget $'Bip001 L Toe0' 100
					PointHelper.controller.rotation.controller = orientation_Constraint ()
					PointHelper.controller.rotation.controller.appendTarget $'Bip001 L Toe0' 100
				)

				if $Check_R_Toe == undefined do
				(
					PointHelper = Point cross: true box: false size: 10 wirecolor: white
					PointHelper.transform = $'Bip001 R Toe0'.transform
					PointHelper.name = "Check_R_Toe"
					PointHelper.controller.position.controller = Position_Constraint ()
					PointHelper.controller.position.controller.appendTarget $'Bip001 R Toe0' 100
					PointHelper.controller.rotation.controller = orientation_Constraint ()
					PointHelper.controller.rotation.controller.appendTarget $'Bip001 R Toe0' 100
				)
			)

			fn CheckUnder0 FrameRange RToe LToe Percent CurrentSliderTime =
			(
				for f = 0f to FrameRange do
				(
					if f == 0 do (biped.setCurrentLayer BipHipNode.controller 2)
					sliderTime = f
					biped.setTransform RToe #rotation (biped.getTransform RToe #rotation) true
					biped.setTransform LToe #rotation (biped.getTransform LToe #rotation) true
					progressUpdate ((Percent*f/FrameRange)+Percent)
				)
				
				biped.setCurrentLayer BipHipNode.controller 0
				
				for R = 0f to FrameRange do
				(
					if R == 0 do (biped.setCurrentLayer BipHipNode.controller 3)
					sliderTime = R
					if $Check_R_Toe.pos.z <= 0 do
					(
						biped.setTransform $'Bip001 R Toe0' #pos ((biped.getTransform $'Bip001 R Toe0' #pos) * [1,1,0]) true
					)
					progressUpdate ((Percent*R/FrameRange)+Percent*2)
				)
					for L = 0f to FrameRange do
				(
					if L == 0 do (biped.setCurrentLayer BipHipNode.controller 3)
					slidertime = L
					if $Check_L_Toe.pos.z <= 0 do
					(
						biped.setTransform $'Bip001 L Toe0' #pos ((biped.getTransform $'Bip001 L Toe0' #pos) * [1,1,0]) true
					)
					progressUpdate ((Percent*L/FrameRange)+Percent*3)
				)
				sliderTime = CurrentSliderTime
			)

			fn DeleteThatPoint =
			(
				delete $Check_R_Toe
				delete $Check_L_Toe
			)
			
			fn ZeroPelvis FrameRange Percent BipHipNode CurrentSliderTime =
			(
				slidertime = 0
				for k = 0f to FrameRange do
				(
					if k == 0 do (biped.setCurrentLayer BipHipNode.controller 1)
					sliderTime = k
					biped.setTransform BipHipNode #pos ((biped.getTransform BipHipNode #pos) * [0,0,1]) true -- True = SetKey!
					progressUpdate (Percent*k/FrameRange)
				)
				sliderTime = CurrentSliderTime
			)

			if chkfoot.checked == false do Percent = 100
			progressStart "Preper MoCap Data."
			ZeroPelvis()
			if chkfoot.checked == true do CreateThatPoint()
			if chkfoot.checked == true do CheckUnder0 FrameRange RToe LToe Percent CurrentSliderTime
			progressEnd()
			if chkfoot.checked == true do DeleteThatPoint()
			try(destroydialog PickBipRoot)catch()
		)
	)
	createdialog PickBipRoot
)